;MOVING MESSAGE DESTINY PREDICTOR - Version 1
;BRILLIANT LED PROJECTS - Nick Dossis - McGraw Hill 2011
;PIC 16F628 - utilises the internal 4Mhz oscillator
;Uses direct addressing which allows custom text to be used in a retlw format 
;Also utilises PCLATH to allow tables to be distributed through the program
;Includes an animated display function when the key is being pressed

#DEFINE BANK0 bcf STATUS,5
#DEFINE BANK1 bsf STATUS,5

           list p=16f628       ; 
                                

           include p16f628.inc ; 

           __config  $3F30     ; internal 4MHz oscillator

	CBLOCK h'20'	;
COUNTB      ;PORT B Column counter
LOOP        ;loop counter 
TIMER       ;timer variable
SPEED       ;speed of message
XSPEED      ;speed of animated display
SPOS        ;start position
EPOS        ;end position
MAP         ;frame image map
TEMP  	    ;temp store
LOOP2 	    ;loop2 variable
RANDOM	    ;random number
CLOCK	    ;clock count
ELOOP	    ;end of loop
FLAG	    ;flag for start up message
	ENDC	;

           ORG 0               ; 
           goto BEGIN
           ORG 4               ; 
           goto BEGIN
           ORG 5               ; 
           goto BEGIN

POSIT:  addwf PCL,F	;frame position table
	retlw 0		;increments in sections of 4 as each character comprises 4 bytes of data
        retlw 4		;a
        retlw 8	 	;b
	retlw 12	;c
        retlw 16	;d
        retlw 20	;e
	retlw 24	;f
        retlw 28	;g
        retlw 32	;h
	retlw 36	;i
        retlw 40	;j
        retlw 44	;k
        retlw 48	;l
	retlw 52	;m
	retlw 56	;n
	retlw 60	;o
	retlw 64	;p
	retlw 68	;q
	retlw 72	;r
	retlw 76	;s
	retlw 80	;t
	retlw 84	;u
	retlw 88	;v
	retlw 92	;w
	retlw 96	;x
	retlw 100	;y
	retlw 104	;z
	retlw 108	;0
	retlw 112	;1
	retlw 116	;2
	retlw 120	;3
	retlw 124	;4
	retlw 128	;5
	retlw 132	;6
	retlw 136	;7
	retlw 140	;8
	retlw 144	;9
	retlw 148	;?
	retlw 152	;!

;Character set
FRAME:  addwf PCL,F     ;character table - each 4 byte chunk = 1 character
       	retlw %00000000 ;space
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00011110 ;a
        retlw %00001001 ;
        retlw %00011110 ;
        retlw %00000000 ;
        retlw %00011111 ;b
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00000000 ;

        retlw %00001110 ;c
        retlw %00010001 ;
        retlw %00001010 ;
        retlw %00000000 ;
        retlw %00011111 ;d
        retlw %00010001 ;
        retlw %00001110 ;
        retlw %00000000 ;

        retlw %00011111 ;e
        retlw %00010101 ;
        retlw %00010001 ;
        retlw %00000000 ;
        retlw %00011111 ;f
        retlw %00000101 ;
        retlw %00000001 ;
        retlw %00000000 ;

        retlw %00001110 ;g
        retlw %00010001 ;
        retlw %00001101 ;
        retlw %00000000 ;
        retlw %00011111 ;h
        retlw %00000100 ;
        retlw %00011111 ;
        retlw %00000000 ;

        retlw %00010001 ;i
        retlw %00011111 ;
        retlw %00010001 ;
        retlw %00000000 ;
        retlw %00010001 ;j
        retlw %00001111 ;
        retlw %00000001 ;
        retlw %00000000 ;

        retlw %00011111 ;k
        retlw %00000100 ;
        retlw %00011011 ;
        retlw %00000000 ;
        retlw %00011111 ;l
        retlw %00010000 ;
        retlw %00010000 ;
        retlw %00000000 ;

        retlw %00011111 ;m
        retlw %00000010 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00011110 ;n
        retlw %00000001 ;
        retlw %00011110 ;
        retlw %00000000 ;

        retlw %00001110 ;o
        retlw %00010001 ;
        retlw %00001110 ;
        retlw %00000000 ;
        retlw %00011111 ;p
        retlw %00000101 ;
        retlw %00000110 ;
        retlw %00000000 ;

        retlw %00000110 ;q
        retlw %00001001 ;
        retlw %00010110 ;
        retlw %00000000 ;
        retlw %00011111 ;r
        retlw %00000101 ;
        retlw %00011010 ;
        retlw %00000000 ;

        retlw %00010010 ;s
        retlw %00010101 ;
        retlw %00001001 ;
        retlw %00000000 ;
        retlw %00000001 ;t
        retlw %00011111 ;
        retlw %00000001 ;
        retlw %00000000 ;

        retlw %00001111 ;u
        retlw %00010000 ;
        retlw %00001111 ;
        retlw %00000000 ;
        retlw %00000111 ;v
        retlw %00011000 ;
        retlw %00000111 ;
        retlw %00000000 ;

        retlw %00011111 ;w
        retlw %00001000 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00011011 ;x
        retlw %00000100 ;
        retlw %00011011 ;
        retlw %00000000 ;

        retlw %00010111 ;y
        retlw %00010100 ;
        retlw %00001111 ;
        retlw %00000000 ;
        retlw %00011001 ;z
        retlw %00010101 ;
        retlw %00010011 ;
        retlw %00000000 ;

        retlw %00001110 ;0
        retlw %00010001 ;
        retlw %00001110 ;
        retlw %00000000 ;
        retlw %00010010 ;1
        retlw %00011111 ;
        retlw %00010000 ;
        retlw %00000000 ;

        retlw %00011001 ;2
        retlw %00010101 ;
        retlw %00010010 ;
        retlw %00000000 ;
        retlw %00010001 ;3
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00000000 ;

        retlw %00000111 ;4
        retlw %00000100 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00010011 ;5
        retlw %00010101 ;
        retlw %00001101 ;
        retlw %00000000 ;

        retlw %00001110 ;6
        retlw %00010101 ;
        retlw %00001001 ;
        retlw %00000000 ;
        retlw %00000001 ;7
        retlw %00011101 ;
        retlw %00000011 ;
        retlw %00000000 ;

        retlw %00001010 ;8
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00000000 ;
        retlw %00010010 ;9
        retlw %00010101 ;
        retlw %00001110 ;
        retlw %00000000 ;

        retlw %00000001 ;?
        retlw %00010101 ;
        retlw %00000010 ;
        retlw %00000000 ;
        retlw %00000000 ;'
        retlw %00000011 ;
        retlw %00000000 ;
        retlw %00000000 ;

MMAP:	addwf PCL,F     ;memory map to get the random message
       	retlw 0         ;increments in steps of 16
        retlw 16 	;because this is the length of each message
        retlw 32 	;
        retlw 48 	;
       	retlw 64 	;
        retlw 80 	;
        retlw 96 	;
        retlw 112 	;
        retlw 128 	;
        retlw 144 	;
        retlw 160	;
        retlw 176 	;
        retlw 192 	;
        retlw 208 	;
        retlw 224 	;
        retlw 240	;

SMESS:  addwf PCL,F     ;Startup message 'ask a question'
       	retlw 'a'       ;
        retlw 's' 	;
        retlw 'k' 	;
        retlw ' ' 	;
       	retlw 'a' 	;
        retlw ' ' 	;
        retlw 'q' 	;
        retlw 'u' 	;
       	retlw 'e' 	;
        retlw 's' 	;
        retlw 't' 	;
        retlw 'i' 	;
       	retlw 'o' 	;
        retlw 'n' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

;start of the program

BEGIN:	

RATE: .EQU 40		;CHANGE THIS NUMBER TO ALTER THE SCREEN SPEED, low value=fast speed, high=slower speed
XRATE: .EQU 20		;
DIRAD: .EQU $2E		;START ADDRESS FOR DIRECT ADDRESSES
        
	BANK1	        ;
        clrf TRISA      ;port a as outputs
 	movlw %10000000	;
	movwf TRISB	;port B outputs except bit 7 input
        movlw %10000000 ;TMR0 rate = 1:2
        movwf OPTION_REG;bit 7 high = pull-ups off
	BANK0	        ;
	
	movlw RATE      ;sets the speed of the moving image, low value=fast speed, high=slower speed
	movwf SPEED	;the value = the number of times the frame is repeated on the screen before the next frame is shown

	movlw XRATE      ;sets the speed of the moving image, low value=fast speed, high=slower speed
	movwf XSPEED	;the value = the number of times the frame is repeated on the screen before the next frame is shown

;Text conditioning and storage into direct addresses

BEGIN2:	clrf PORTB      ;clears variables and ports
        clrf COUNTB     ;
	clrf TIMER	;
	clrf LOOP	;
	clrf LOOP2	;
	clrf SPOS	;
	clrf EPOS	;
	clrf CLOCK	;
	clrf PCLATH	;
	clrf FLAG	;
	movlw 16	;moves 16 into eloop to capture the end of each message
	movwf ELOOP	;

DIRECT: movlw DIRAD     ;this routine populates the direct addresses
        movwf FSR       ;and copies the DIRAD start address into the Indirect address reg

;clear the first 7 memory locations of the direct addresses to allow smooth scrolling of text

CLSS:	clrf INDF	;clears the indirect file to create a space at the start of the message
	incf FSR,F	;increment FSR
	movf LOOP2,W	;
	xorlw 7		;compares loop2 variable
	btfsc STATUS,Z	;does loop2 = 7
	goto DIRECT2	;yes, now go to populate the message text into the rest of the direct addresses
	incf LOOP2,F	;no, loop around until all 7 spaces are complete
	goto CLSS	;
	
DIRECT2:movlw 4		;moves 4 to w to set up 4 bytes per letter
	movwf LOOP2	;moves it to loop2 which = byte address	       

STORE:  btfss FLAG,7	;tests flag to see if start up message should be shown, if bit 7 is low then show the start up message
	goto INTRO	;yes its low, goto startup message routine	 
	movlw 2		;Change the PCLATH memory page to get the message text in the middle of the program
	movwf PCLATH	;enters 2 into PCLATH
	movf LOOP,w     ;moves w into loop
	call MESS       ;gets message letter from table at the end of the program
	movwf TEMP	;moves message letter into temp
	clrf PCLATH	;Clears PCLATH to reverts back to normal page

TEST:	movf TEMP,w	;moves table text to w
	xorlw 32        ;is it a space?
        btfsc STATUS,Z  ;
        goto SPACE      ;yes, goto space routine

	movf TEMP,w	;moves table text to w
	xorlw 63        ;is it a ?
        btfsc STATUS,Z  ;
        goto QUESTN     ;yes, goto question mark routine

	movf TEMP,w	;moves table text to w
	xorlw 39        ;is it a '
        btfsc STATUS,Z  ;
        goto APOST      ;yes, goto apostrophe routine 39

	btfss TEMP,6	;tests to see if the character is a number
	goto NUMBER	;yes, call the number routine
	bcf TEMP,6	;no, clears bits to prepare to get data
	bcf TEMP,5	;

STORE2:	movf TEMP,w	;moves temp position file to w
	call POSIT	;calls position map
	movwf TEMP	;moves start postion into temp file
ST3:	movf TEMP,W	;moves temp back to w
	call FRAME	;gets the frame image
        movwf INDF      ;moves w into indirect file
	incf RANDOM,F	;increment random number
        incf FSR,F      ;increments fsr
	incf TEMP,F	;increments temp position file to go to next image byte location      
	decfsz LOOP2,F  ;has 4 byte loop count reached zero?
        goto ST3        ;no, loop round	

	incf LOOP,F	;yes, increment loop
	movf LOOP,W     ;increment loop
        xorwF ELOOP,W   ;tests to see if 16 letters are done
        btfsc STATUS,Z  ;which is set by the value of ELOOP set in the BEGIN sub-routine
        goto CLSE       ;yes, go and set spaces at the end of the messages 
	goto DIRECT2	;no, go back around

SPACE:	movlw 0		;moves 0 to w, 0 is the position of a space in the lookup table
	movwf TEMP	;moves it to temp file
	goto STORE2	;go back to routine

QUESTN:	movlw 37	;moves 37 to w, this is the position of the question mark
	movwf TEMP	;moves it to temp file
	goto STORE2	;go back to routine

APOST:	movlw 38	;moves 38 to w, this is the position of the apostrophe
	movwf TEMP	;moves it to temp file
	goto STORE2	;go back to routine

NUMBER:	bcf TEMP,4	;clears bits to prep for a number
	bcf TEMP,5	;
	movlw 27	;moves 27 to w
	addwf TEMP,F	;adds it to the temp file
	goto STORE2	;

;routine to show the startup message

INTRO:	movf LOOP,w     ;moves w into loop
	call SMESS      ;gets message letter
	movwf TEMP	;moves message letter into temp
	goto TEST	;

;clears last 7 memory allocations to create spaces at the end of the message

CLSE:	clrf LOOP2	;clear loop 2
CLS:	clrf INDF	;clear indirect file to create a space
	incf FSR,F	;increment FSR
	movf LOOP2,W	;
	xorlw 7		;have all 7 characters been done?
	btfsc STATUS,Z	;does loop = 7
	goto TIME	;yes, go to the display driver routines
	incf LOOP2,F	;no, loop around until done
	goto CLS	;

;display driver routines, this is how the stored images are shown on the display

TIME:	clrf TIMER	;
	clrf MAP	;clears all key variables
	clrf SPOS	;
	clrf EPOS	;
	movlw DIRAD     ;this routine populates the direct addresses
        movwf FSR       ;copy DIRAD into Indirect address reg
	movlw DIRAD     ;this routine populates the direct addresses
        movwf SPOS      ;copy DIRAD into start position
        clrf LOOP       ;clears loop	

START:	movlw %00000001	;moves 1 into w
	movwf COUNTB	;which is used to activate the 1st LED column of port b
	movf SPOS,W	;moves start position to w
	movwf FSR	;and moves it to FSR

CLEAR1:	movf SPOS,W	;move start position to loop
	movwf LOOP	;
	movf LOOP,W	;
	addlw 7		;adds 7 to start position to create the end position, ie one full 7 wide LED frame
	movwf EPOS	;move value to end position

TIME1:	incf TIMER,F	;increments timer
	movf TIMER,W    ;increment timing loop
        xorwf SPEED,W   ;tests to see if timer = speed
        btfsc STATUS,Z  ;if timer = speed then we need to see the next image
        goto TIME2      ;yes, show next image
 
IMAGE:	clrf PORTB	;no,switches off all columns

KEY:	btfsc PORTB,7	;tests port b input, is it being pressed?
	goto XBEGIN	;yes, goto txt routine

	movf INDF,w	;no, move next indirect file to w

	movwf TEMP	;
	btfsc TEMP,4	;tests PORTA output 4
	bsf TEMP,6	;copies PORTA output 4 to 6
	movf TEMP,W	;

        movwf PORTA     ;moves the image byte to port A

	movf COUNTB,W	;moves column counter to w
	movwf PORTB	;activates the next column to illuminate it

	call DELAY	;creates a delay to allow the image to be stable

LOOP1:	rlf COUNTB,F	;rotates column data for Port B to the left	
	incf RANDOM,F	;increments random number
	incf LOOP,F	;increment loop
        movf LOOP,W     ;increment loop
        xorwf EPOS,w    ;tests to see if 7 characters bytes have been shown
        btfsc STATUS,Z  ;
        goto START      ;yes, start all over again
	movf LOOP,W	;
	movwf FSR	;no, move loop value to FSR
	goto IMAGE	;loop until all bytes are shown

;routine to increment the map position to show the next image

TIME2:	incf MAP,F	;increment map position
	clrf TIMER	;clears the timer
	movf MAP,W	;
	xorlw 72        ;have all 16 letters and additional spaces been shown?
        btfsc STATUS,Z  ;
	goto BEGIN2	;yes, go to the beginning to show the start up message
	incf SPOS,F	;increment start position
	goto START	;go back to show the next image

;Delay routine to slow the image speed so it is readable

DELAY   movlw 1         ; set delay counter to 1
        movwf CLOCK     ; (for 1/25th sec x 5)
        clrf INTCON             ; clear interupt flag
DELAY2  btfss INTCON,2          ; has a timer time-out been detected?
        goto DELAY2             ; no
        bcf INTCON,2            ; yes
        decfsz CLOCK,F         ; dec counter, is it zero?
        goto DELAY2             ; no
        return                  ; yes

;The button is being pressed get the random number

GETTXT: clrf PCLATH	;reset PCLATH for page 0

GTXT:	btfss PORTB,7	;is the button still being pressed?
	goto GTXT2	;no, go and get the random number
	incf RANDOM,F	;keep incrementing the random number
	goto GTXT	;loop around

GTXT2:	movf RANDOM,W	;move the random number to w
	andlw %00001111	;remove the upper 4 bits to make the random number 0-15
	movwf TEMP	;
	movf TEMP,W	;
	xorlw 15	;
	btfsc STATUS,Z	;is temp file 15
	clrf TEMP	;yes
	movf TEMP,W	;no, move file to w
	call MMAP	;call the message map
	movwf LOOP	;move the map to loop
	movf LOOP,W	;move the loop to w
	addlw 16	;adds 16 to start position to create the end position
	movwf ELOOP	;and moves it to ELOOP variable
	bsf FLAG,7	;sets flag so start up message isn't shown
	clrf LOOP2	;clear loop2
	goto DIRECT	;now goto the direct routine to populate the direct addresses with the random message


	ORG 512	;

;message memory table
;text can be in upper or lower case and can contain numbers, ?, ', and spaces 

MESS:	addwf PCL,F     ;Message 1 = 16 x 4 bytes = 64 indirect addresses plus blanks at front and back of message
       	retlw 'm'       ;
        retlw 'o' 	;
        retlw 'r' 	;
        retlw 'e' 	;
       	retlw ' ' 	;
        retlw 't' 	;
        retlw 'h' 	;
        retlw 'a' 	;
       	retlw 'n' 	;
        retlw ' ' 	;
        retlw 'l' 	;
        retlw 'i' 	;
       	retlw 'k' 	;
        retlw 'e' 	;
       	retlw 'l' 	;
        retlw 'y' 	;

       	retlw 'I'       ;message 2
        retlw ''' 	;
        retlw 'm' 	;
        retlw ' ' 	;
       	retlw 's' 	;
        retlw 'a' 	;
        retlw 'y' 	;
        retlw 'i' 	;
       	retlw 'n' 	;
        retlw 'g' 	;
        retlw ' ' 	;
        retlw 'n' 	;
       	retlw 'o' 	;
        retlw ' ' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'd'       ;message 3
        retlw 'e' 	;
        retlw 'f' 	;
        retlw 'i' 	;
       	retlw 'n' 	;
        retlw 'i' 	;
        retlw 't' 	;
        retlw 'e' 	;
       	retlw 'l' 	;
        retlw 'y' 	;
        retlw ' ' 	;
        retlw 'y' 	;
       	retlw 'e' 	;
        retlw 's' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 4
        retlw 't' 	;
        retlw ''' 	;
        retlw 's' 	;
       	retlw ' ' 	;
        retlw 'a' 	;
        retlw ' ' 	;
        retlw 's' 	;
       	retlw 'a' 	;
        retlw 'f' 	;
        retlw 'e' 	;
        retlw ' ' 	;
       	retlw 'b' 	;
        retlw 'e' 	;
       	retlw 't' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 5
        retlw ' ' 	;
        retlw 'p' 	;
        retlw 'r' 	;
       	retlw 'e' 	;
        retlw 'd' 	;
        retlw 'i' 	;
        retlw 'c' 	;
       	retlw 't' 	;
        retlw ' ' 	;
        retlw 'a' 	;
        retlw ' ' 	;
       	retlw 'n' 	;
        retlw 'o' 	;
      	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'p'       ;message 6
        retlw 'l' 	;
        retlw 'e' 	;
        retlw 'a' 	;
       	retlw 's' 	;
        retlw 'e' 	;
        retlw ' ' 	;
        retlw 'a' 	;
       	retlw 's' 	;
        retlw 'k' 	;
        retlw ' ' 	;
        retlw 'a' 	;
       	retlw 'g' 	;
        retlw 'a' 	;
       	retlw 'i' 	;
        retlw 'n' 	;

       	retlw 'y'       ;message 7
        retlw 'e' 	;
        retlw 's' 	;
        retlw ' ' 	;
       	retlw 'y' 	;
        retlw 'e' 	;
        retlw 's' 	;
        retlw ' ' 	;
       	retlw 'y' 	;
        retlw 'e' 	;
        retlw 's' 	;
        retlw ' ' 	;
       	retlw 'y' 	;
        retlw 'e' 	;
       	retlw 's' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 8
        retlw ''' 	;
        retlw 'm' 	;
        retlw ' ' 	;
       	retlw 's' 	;
        retlw 'a' 	;
        retlw 'y' 	;
        retlw 'i' 	;
       	retlw 'n' 	;
        retlw 'g' 	;
        retlw ' ' 	;
        retlw 'y' 	;
       	retlw 'e' 	;
        retlw 's' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 9
        retlw 't' 	;
        retlw ' ' 	;
        retlw 'w' 	;
       	retlw 'o' 	;
        retlw 'n' 	;
        retlw ''' 	;
        retlw 't' 	;
       	retlw ' ' 	;
        retlw 'h' 	;
        retlw 'a' 	;
        retlw 'p' 	;
       	retlw 'p' 	;
        retlw 'e' 	;
       	retlw 'n' 	;
        retlw ' ' 	;

       	retlw 't'       ;message 10
        retlw 'r' 	;
        retlw 'y' 	;
        retlw ' ' 	;
       	retlw 'a' 	;
        retlw 'g' 	;
        retlw 'a' 	;
        retlw 'i' 	;
       	retlw 'n' 	;
        retlw ' ' 	;
        retlw 'l' 	;
        retlw 'a' 	;
       	retlw 't' 	;
        retlw 'e' 	;
       	retlw 'r' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 11
        retlw ' ' 	;
        retlw 'p' 	;
        retlw 'r' 	;
       	retlw 'e' 	;
        retlw 'd' 	;
        retlw 'i' 	;
        retlw 'c' 	;
       	retlw 't' 	;
        retlw ' ' 	;
        retlw 'a' 	;
        retlw ' ' 	;
       	retlw 'y' 	;
        retlw 'e' 	;
       	retlw 's' 	;
        retlw ' ' 	;

       	retlw 'n'       ;message 12
        retlw 'o' 	;
        retlw 't' 	;
        retlw ' ' 	;
       	retlw 'a' 	;
        retlw ' ' 	;
        retlw 'c' 	;
        retlw 'h' 	;
       	retlw 'a' 	;
        retlw 'n' 	;
        retlw 'c' 	;
        retlw 'e' 	;
       	retlw ' ' 	;
        retlw ' ' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 13
        retlw ' ' 	;
        retlw 'h' 	;
        retlw 'a' 	;
       	retlw 'v' 	;
        retlw 'e' 	;
        retlw ' ' 	;
        retlw 'n' 	;
       	retlw 'o' 	;
        retlw ' ' 	;
        retlw 'a' 	;
        retlw 'n' 	;
       	retlw 's' 	;
        retlw 'w' 	;
       	retlw 'e' 	;
        retlw 'r' 	;

       	retlw 'i'       ;message 14
        retlw 't' 	;
        retlw ' ' 	;
        retlw 'w' 	;
       	retlw 'i' 	;
        retlw 'l' 	;
        retlw 'l' 	;
        retlw ' ' 	;
       	retlw 'h' 	;
        retlw 'a' 	;
        retlw 'p' 	;
        retlw 'p' 	;
       	retlw 'e' 	;
        retlw 'n' 	;
       	retlw ' ' 	;
        retlw ' ' 	;

       	retlw 'i'       ;message 15
        retlw ' ' 	;
        retlw 'n' 	;
        retlw 'e' 	;
       	retlw 'e' 	;
        retlw 'd' 	;
        retlw ' ' 	;
        retlw 't' 	;
       	retlw 'o' 	;
        retlw ' ' 	;
        retlw 't' 	;
        retlw 'h' 	;
       	retlw 'i' 	;
        retlw 'n' 	;
       	retlw 'k' 	;
        retlw ' ' 	;

;routine to show the animated display when the key is being pressed

XBEGIN:	clrf PORTB      ;clears variables and ports
        clrf COUNTB     ;
	clrf TIMER	;
	clrf LOOP	;
	clrf SPOS	;
	clrf EPOS	;
	clrf CLOCK	;

	movlw 4		;Sets up the PCLATH memory page to access the tables at the end of the program
	movwf PCLATH	;enters 4 into PCLATH
        
XTIME:	clrf TIMER	;
	clrf MAP	;clears all key variables
	clrf SPOS	;
	clrf EPOS	;
	goto XST	;

XSTART:	
XST:	movlw %00000001	;
	movwf COUNTB	;activates the 1st column

XCLEAR1:movf SPOS,W	;move start position to loop
	movwf LOOP	;
	movf LOOP,W	;
	addlw 7		;adds 7 to start position to create the end position
	movwf EPOS	;move to end position

XTIME1:	incf TIMER,F	;increments timer
	movf TIMER,W    ;increment timing loop
        xorwf XSPEED,W  ;tests to see if timer = speed
        btfsc STATUS,Z  ;if timer = speed then we need to see the next image
        goto XTIME2     ;yes, show next image
 
XIMAGE:	clrf PORTB	;no,switches off all columns

XKEY:	btfss PORTB,7	;tests port b input, is it being pressed?
	goto GETTXT	;no, goto txt routine

	movf LOOP,W     ;moves loop into w
        call XFRAME     ;calls image byte

	movwf TEMP	;
	btfsc TEMP,4	;tests PORTA output 4
	bsf TEMP,6	;copies PORTA output 4 to 6
	movf TEMP,W	;

        movwf PORTA     ;moves the image byte to port A

	movf COUNTB,W	;moves column counter to w
	movwf PORTB	;activates the next column to illuminate it

	call DELAY	;creates a delay to allow the image to be stable

XLOOP1:	rlf COUNTB,F	;rotates column data to the left
	incf RANDOM,F	;increments the random number	
	incf LOOP,F	;increment loop
        movf LOOP,W     ;increment loop
        xorwf EPOS,w    ;tests to see if 7 characters bytes have been shown
        btfsc STATUS,Z  ;
        goto XSTART     ;yes, start all over again
	goto XIMAGE	;no, loop until all bytes are shown

;routine to increment the map position to show the next image

XTIME2:	incf MAP,F	;increment map position
	clrf TIMER	;clears the timer
	movf MAP,W	;
	xorlw 28        ;have all 28 images been shown?
        btfsc STATUS,Z  ;
	goto XTIME	;yes, goto the start of the routine
	movf MAP,W	;no, carry on
	call XPOSIT	;get start position from the image map table
	movwf SPOS	;move it to start position variable
	goto XSTART	;go back to show the next image

XDELAY  movlw 1         ; set delay counter to 1
        movwf CLOCK    ; (for 1/25th sec x 5)
        clrf INTCON     ; clear interupt flag
XDELAY2 btfss INTCON,2  ; has a timer time-out been detected?
        goto XDELAY2    ; no
        bcf INTCON,2    ; yes
        decfsz CLOCK,F ; dec counter, is it zero?
        goto XDELAY2    ; no
        return          ; yes

;animated display tables

	ORG 1024	;

XPOSIT:  addwf PCL,F	;frame position table
	retlw 0		;increments in sections of 7
        retlw 7		;as each image frame comprises 7 bytes of data
        retlw 14	;
	retlw 21	;
        retlw 28	;
        retlw 35	;
	retlw 42	;
        retlw 49	;
        retlw 56	;
	retlw 63	;
        retlw 70	;
        retlw 77	;
        retlw 84	;
	retlw 91	;
	retlw 98	;
	retlw 105	;
	retlw 112	;
	retlw 119	;
	retlw 126	;
	retlw 133	;
	retlw 140	;
	retlw 147	;
	retlw 154	;
	retlw 161	;
	retlw 168	;
	retlw 175	;
	retlw 182	;
	retlw 189	;

;limit the animation to a maximum of 28 frames

XFRAME:  addwf PCL,F     ;image table - each 7 byte chunk = 1 image frame
        retlw %00000000 ;1										
        retlw %00000000 ;										
        retlw %00000000 ;										
        retlw %00000100 ;										
        retlw %00000000 ;										
        retlw %00000000 ;										
        retlw %00000000 ;										

        retlw %00000000 ;2
        retlw %00000000 ;
        retlw %00001110 ;
        retlw %00001010 ;
        retlw %00001110 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;3
        retlw %00011111 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00011111 ;
        retlw %00000000 ;

        retlw %00011111 ;4
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00011111 ;

        retlw %00000000 ;5
        retlw %00011111 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00010001 ;
        retlw %00011111 ;
        retlw %00000000 ;

        retlw %00000000 ;6
        retlw %00000000 ;
        retlw %00001110 ;
        retlw %00001010 ;
        retlw %00001110 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;7
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000100 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000100 ;8
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000100 ;

        retlw %00001010 ;9
        retlw %00000100 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000100 ;
        retlw %00001010 ;

        retlw %00010001 ;10
        retlw %00001010 ;
        retlw %00000100 ;
        retlw %00000000 ;
        retlw %00000100 ;
        retlw %00001010 ;
        retlw %00010001 ;

        retlw %00000000 ;11
        retlw %00010001 ;
        retlw %00001010 ;
        retlw %00000100 ;
        retlw %00001010 ;
        retlw %00010001 ;
        retlw %00000000 ;

        retlw %00000000 ;12
        retlw %00000000 ;
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00010101 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;13
        retlw %00000100 ;
        retlw %00001010 ;
        retlw %00010001 ;
        retlw %00001010 ;
        retlw %00000100 ;
        retlw %00000000 ;

        retlw %00000100 ;14
        retlw %00001010 ;
        retlw %00010001 ;
        retlw %00000000 ;
        retlw %00010001 ;
        retlw %00001010 ;
        retlw %00000100 ;

        retlw %00001010 ;15
        retlw %00010001 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00010001 ;
        retlw %00001010 ;

        retlw %00010001 ;16
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00010001 ;

        retlw %00000000 ;17
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;18
        retlw %00000000 ;
        retlw %00010000 ;
        retlw %00000000 ;
        retlw %00000001 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;19
        retlw %00010000 ;
        retlw %00001000 ;
        retlw %00010001 ;
        retlw %00000010 ;
        retlw %00000001 ;
        retlw %00000000 ;

        retlw %00010000 ;20
        retlw %00001000 ;
        retlw %00000101 ;
        retlw %00001010 ;
        retlw %00010100 ;
        retlw %00000010 ;
        retlw %00000001 ;

        retlw %00001000 ;21
        retlw %00000100 ;
        retlw %00000010 ;
        retlw %00000100 ;
        retlw %00001000 ;
        retlw %00000100 ;
        retlw %00000010 ;

        retlw %00000100 ;22
        retlw %00000010 ;
        retlw %00000101 ;
        retlw %00001010 ;
        retlw %00010100 ;
        retlw %00001000 ;
        retlw %00000100 ;

        retlw %00000010 ;23
        retlw %00000001 ;
        retlw %00001000 ;
        retlw %00010001 ;
        retlw %00000010 ;
        retlw %00010000 ;
        retlw %00001000 ;

        retlw %00000001 ;24
        retlw %00000000 ;
        retlw %00010000 ;
        retlw %00000000 ;
        retlw %00000001 ;
        retlw %00000000 ;
        retlw %00010000 ;

        retlw %00000000 ;25
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;26
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;27
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00000000 ;28
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;
        retlw %00000000 ;


        .END            ;