;LED MATRIX DUAL DIGIT COUNTER - Version 1
;BRILLIANT LED PROJECTS - Nick Dossis - McGraw Hill 2011
;16F628 - internal 4Mhz clock
;Uses direct addressing 

#DEFINE BANK0 bcf STATUS,5
#DEFINE BANK1 bsf STATUS,5

           list p=16f628       ; 
                               ; 

           include p16f628.inc ; 

           __config  $3F30     ; internal 4MHz oscillator

	CBLOCK h'20'	;
COUNTB      ;PORT B Column counter
LOOP        ;loop counter 
TIMER       ;
SPEED       ;speed of message
SPOS        ;start position
EPOS        ;end position
MAP         ;frame image map
TEMP  	    ;temp store
LOOP2 	    ;
TENS	    ;counter value
UNITS	    ;
FLAG	    ;
RESET       ;
CLOCK	    ; 	
CHAR	    ;determines the character set

	ENDC	;

RATE: .EQU 3	;CHANGE THIS TO ALTER THE DEBOUNCE TIME OF THE CLK INPUT & SCREEN SPEED, low value=fast speed, high=slower speed
DIRAD: .EQU $32	;START ADDRESS FOR DIRECT ADDRESSES

           ORG 0               ; 
           goto BEGIN
           ORG 4               ; 
           goto BEGIN
           ORG 5               ;
           goto BEGIN

POSIT:  addwf PCL,F	;frame position table
	retlw 0		;0 - increments in sections of 4 as each image comprises 4 bytes of data
        retlw 4		;1
        retlw 8	 	;2
	retlw 12	;3
        retlw 16	;4
        retlw 20	;5
	retlw 24	;6
        retlw 28	;7
        retlw 32	;8
	retlw 36	;9

;Character set
FRAME1:  addwf PCL,F     ;number character table - each 4 byte chunk = 1 character
        retlw %00001110 ;0
        retlw %00010001 ;
        retlw %00001110 ;
        retlw %00000000 ;
        retlw %00010010 ;1
        retlw %00011111 ;
        retlw %00010000 ;
        retlw %00000000 ;

        retlw %00011001 ;2
        retlw %00010101 ;
        retlw %00010010 ;
        retlw %00000000 ;
        retlw %00010001 ;3
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00000000 ;

        retlw %00000111 ;4
        retlw %00000100 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00010011 ;5
        retlw %00010101 ;
        retlw %00001101 ;
        retlw %00000000 ;

        retlw %00001110 ;6
        retlw %00010101 ;
        retlw %00001001 ;
        retlw %00000000 ;
        retlw %00000001 ;7
        retlw %00011101 ;
        retlw %00000011 ;
        retlw %00000000 ;

        retlw %00001010 ;8
        retlw %00010101 ;
        retlw %00001010 ;
        retlw %00000000 ;
        retlw %00010010 ;9
        retlw %00010101 ;
        retlw %00001110 ;
        retlw %00000000 ;

;Alternative Character set
FRAME2:  addwf PCL,F     ;number character table - each 4 byte chunk = 1 character
        retlw %00011111 ;0
        retlw %00010001 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00000000 ;1
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00000000 ;

        retlw %00011101 ;2
        retlw %00010101 ;
        retlw %00010111 ;
        retlw %00000000 ;
        retlw %00010001 ;3
        retlw %00010101 ;
        retlw %00011111 ;
        retlw %00000000 ;

        retlw %00000111 ;4
        retlw %00000100 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00010111 ;5
        retlw %00010101 ;
        retlw %00011101 ;
        retlw %00000000 ;

        retlw %00011111 ;6
        retlw %00010101 ;
        retlw %00011101 ;
        retlw %00000000 ;
        retlw %00000001 ;7
        retlw %00000001 ;
        retlw %00011111 ;
        retlw %00000000 ;

        retlw %00011111 ;8
        retlw %00010101 ;
        retlw %00011111 ;
        retlw %00000000 ;
        retlw %00000111 ;9
        retlw %00000101 ;
        retlw %00011111 ;
        retlw %00000000 ;

;start of program

BEGIN:	clrf PORTB      ;clears variables and ports
        clrf COUNTB     
	clrf TIMER	
	clrf LOOP	
	clrf SPOS	
	clrf EPOS	
        clrf TENS	
	clrf UNITS	
	clrf FLAG	;debounce flag 
	clrf RESET
	clrf CHAR	;character set flag

	BANK1	;
        clrf TRISA      ;port a and b as outputs, except B7 is an input
	movlw %10000000	;
        movwf TRISB     ;
        movlw %10000001 ;TMR0 rate = 1:4
        movwf OPTION_REG;bit 7 high = pull-ups off
	BANK0	;
	
	movlw RATE      ;sets the speed of the moving image, low value=fast speed, high=slower speed
	movwf SPEED	;the value = the number of times the frame is repeated on the screen before the next frame is shown

DIRECT: movlw DIRAD     ;this routine populates the direct addresses
        movwf FSR       ;copy w into Indirect address reg
        clrf LOOP       ;clears loop

;prepares tens screen data
DIRECT2:movlw 4		;moves 4 to w to set up 4 bytes per letter
	movwf LOOP2	;moves it to loop2 = byte address	       
	movf TENS,W	;move counter number to w
	movwf TEMP	;moves number into temp file
	andlw %00001111	;clears upper 4 bits of w
	call POSIT	;calls position map
	movwf TEMP	;moves start postion into temp file
ST3:	movf TEMP,W	;moves temp back to w
	btfsc CHAR,0	;checks character flag
	call FRAME1	;gets character set 1 frame image
	btfss CHAR,0	;checks character flag
	call FRAME2	;gets character set 2 frame image
        movwf INDF      ;moves w into indirect file
        incf FSR,F      ;increments fsr
	incf TEMP,F	;increments temp position file to go to next image byte location      
	decfsz LOOP2,F  ;has 4 byte loop count reached zero?
        goto ST3        ;no, loop round	

;prepares units screen data
DIRECT3:movlw 4		;moves 4 to w to set up 4 bytes per letter
	movwf LOOP2	;moves it to loop2 = byte address	       
	movf UNITS,W	;move counter number to w
	movwf TEMP	;moves number into temp file
	andlw %00001111	;clears upper 4 bits of w
	call POSIT	;calls position map
	movwf TEMP	;moves start postion into temp file
ST4:	movf TEMP,W	;moves temp back to w
	btfsc CHAR,0	;checks character flag
	call FRAME1	;gets character set 1 frame image
	btfss CHAR,0	;checks character flag
	call FRAME2	;gets character set 2 frame image
        movwf INDF      ;moves w into indirect file
        incf FSR,F      ;increments fsr
	incf TEMP,F	;increments temp position file to go to next image byte location      
	decfsz LOOP2,F  ;has 4 byte loop count reached zero?
        goto ST4        ;no, loop round

;display driver routines

TIME:	clrf TIMER	;
	clrf MAP	;clears all key variables
	clrf SPOS	;
	clrf EPOS	;
	movlw DIRAD     ;this routine populates the direct addresses
        movwf FSR       ;copy w into Indirect address reg
	movlw DIRAD     ;this routine populates the direct addresses
        movwf SPOS      ;copy w into Indirect address reg
        clrf LOOP       ;clears loop	
	goto START	;

START:  clrf PORTB	;clears portb image from screen
	movlw %00000001	;
	movwf COUNTB	;activates 1st column
	movf SPOS,W	;moves start position to w
	movwf FSR	;and moves it to FSR

INPUT:  btfsc PORTB,7	;checks input on B7, is it high?
	call COUNT	;yes, if B7 is pressed/high then call the counter routine to increment digits
	btfss PORTB,7	;check input B7, is it low?
	clrf FLAG	;yes, if B7 is low then clear the flag to allow further counting

	movf RESET,W	;move the reset counter to w
	xorlw 255	;
	btfsc STATUS,Z	;does the reset counter = 255?
	call CLEAR	;yes, reset the display	

CLEAR1:	movf SPOS,W	;move start position to loop
	movwf LOOP	;
	movf LOOP,W	;
	addlw 7		;adds 7 to start position to create the end position
	movwf EPOS	;move to end position

TIME1:	incf TIMER,F	;increments timer
	movf TIMER,W    ;increment timing loop
        xorwf SPEED,W   ;tests to see if timer = speed
        btfsc STATUS,Z  ;if timer = speed then we need to see the next image
	goto DIRECT	;goto start of program 
 
IMAGE:	clrf PORTB	;no,switches off all columns
	movf INDF,W	;

	movwf TEMP	;
	btfsc TEMP,4	;tests PORTA output 4
	bsf TEMP,6	;copies PORTA output 4 to 6
	movf TEMP,W	;

        movwf PORTA     ;moves the image byte to port A
	
	movf COUNTB,W	;moves column counter to w
	movwf PORTB	;activates the next column to illuminate it

	call PAUSE

LOOP1:	rlf COUNTB,F	;rotates column data	
	incf LOOP,F	;increment loop
        movf LOOP,W     ;increment loop
        xorwf EPOS,w    ;tests to see if 8 characters bytes have been shown
        btfsc STATUS,Z  ;
        goto START      ;yes, start all over again
	movf LOOP,W	;
	movwf FSR	;
	goto IMAGE	;no, loop until all bytes are shown

;clock count routine including validity checks for unit and tens values

COUNT:  incf RESET,F	;increment the reset counter
	btfsc FLAG,0	;is flag clear?
	return		;no return to display without incrementing        
	incf UNITS,F	;if input is high and flag is low then increment counter
	movf UNITS,W	;move units to w
	xorlw 10	;
	btfsc STATUS,Z	;does units = 10
	goto TEN	;yes
	bsf FLAG,0	;no, set flag bit for next time
	clrf RESET	;clears the reset counter
	return		;return
TEN:	clrf UNITS	;clear units
	incf TENS,F	;increment tens
	movf TENS,W	;move units to w
	xorlw 10	;
	btfsc STATUS,Z	;does tens = 10
	goto CLEAR	;yes, clear all digits
	bsf FLAG,0	;no, set flag bit for next time
	clrf RESET	;clears the reset counter
	return		;
CLEAR:  clrf TENS	;yes, clear tens
	clrf UNITS	;clear units
	bsf FLAG,0	;no, set flag bit for next time
	movf RESET,W	;move the reset counter to w
	xorlw 255	;
	btfsc STATUS,Z	;does the reset counter = 255?
	call CHARSET	;
	clrf RESET	;
	return

;Routine to change the character set

CHARSET: clrf RESET	;
CHAR2	btfss PORTB,7	;is the button pressed?
	return
	incf RESET,F	;
	call PAUSE2	;
        movf RESET,W	;move the reset counter to w
	xorlw 255	;
	btfss STATUS,Z	;does the reset counter = 255?
	goto CHAR2	;no loop around
	incf CHAR,F	;change the character set
	return

;screen delay routine

PAUSE   movlw 2            ;set pause counter to 2
        movwf CLOCK        ; 
        clrf INTCON        ;clear interupt flag
                            
LOOP4   btfss INTCON,2     ;has the intcon timer time-out been detected?
        goto LOOP4         ;no, loop until it is detected
        bcf INTCON,2       ;yes, clear intcon
        decfsz CLOCK,F     ;decrement the clock counter, is it zero?
        goto LOOP4         ;no
        return             ;yes

;character change delay routine

PAUSE2  movlw 10           ;set pause counter to 10
        movwf CLOCK        ; 
        clrf INTCON        ;clear interupt flag
                            
LOOP5   btfss INTCON,2     ;has the intcon timer time-out been detected?
        goto LOOP5         ;no, loop until it is detected
        bcf INTCON,2       ;yes, clear intcon
        decfsz CLOCK,F     ;decrement the clock counter, is it zero?
        goto LOOP5         ;no
        return             ;yes


        .END            ;