;LED DIGITAL OSCILLOSCOPE SCREEN - Version 1
;BRILLIANT LED PROJECTS - Nick Dossis - McGraw Hill 2011
;7 x 10 LEDs on Port B 
;High signal on Port A,2 increases the speed of the LEDs
;High signal on Port A,3 decreases the speed of the LEDs

#DEFINE BANK0 BCF STATUS,5
#DEFINE BANK1 BSF STATUS,5

           include p16f628.inc

	   CBLOCK h'20'
CLOCK
CLOCK2
SPEED
FLAG
	   ENDC

           __config  $3F30    ;internal 4MHz oscillator

           ORG 0              ;
           goto START
           ORG 4              ;
           goto START
           ORG 5              ; 

START      movlw 7	      ;configure port A as a digital port
           movwf CMCON	      ;	
           clrf PORTA	      
           clrf PORTB	      
           BANK1		
           movlw B'00001100'  ;set Port A2-A3 as inputs, all others are outputs
           movwf TRISA        ;
           movlw B'00000000'  ;set Port B0-B7 as outputs
           movwf PORTB
           movlw B'10000000'  ;TMR0 rate = 1:2
           movwf OPTION_REG   ;bit 7 is high = pull-ups off
           BANK0

           movlw 50	      ;
	   movwf SPEED	      ;sets the sequencer scanning speed=50 as a default
           clrf FLAG

;LED Display Driver Routine

DISPLAY	   bsf PORTB,5
	   call PAUSE
	   clrf PORTB
	   bsf PORTB,4
           call PAUSE
           clrf PORTB
           bsf PORTB,0
           call PAUSE
           clrf PORTB
           bsf PORTB,6
           call PAUSE
           clrf PORTB
	   bsf PORTB,1
           call PAUSE
           clrf PORTB
           bsf PORTB,2
           call PAUSE
           clrf PORTB
           bsf PORTB,3
           call GETKEY
           goto DISPLAY

;Pause routine to alter the speed of the sequencer which is determined by the value of the SPEED variable

PAUSE      movlw 50           ;move 50 into the clock counter to create a delay
           movwf CLOCK         
           movf SPEED,W       ;move value of speed into clock2 variable
           movwf CLOCK2

P1         decfsz CLOCK,F
           goto P1
           movlw 50           ;move 50 into the clock counter to create a delay
           movwf CLOCK         
           decfsz CLOCK2,F    ;decrement the clock2 variable
           goto P1 
           return	      ;when it is 0 return to main 

;Tests for key presses and alters the value of SPEED within the range of 1 - 127

GETKEY     movf PORTA,W	      ;moves the value of port a to w
	   xorlw B'00000000'  ;are any keys pressed?
	   btfsc STATUS,Z     ;
	   goto RFLAG	      ;no, test flag & return
	   btfsc FLAG,0       ;tests flag bit, if 1 then return to display routine
           return             ;
           btfsc PORTA,3      ;yes, is A,3 pressed?
	   incf SPEED,F	      ;yes, increment speed
           btfsc PORTA,2      ;is A,2 pressed?
	   decfsz SPEED,F     ;yes, decrement speed
           goto G1          
           call RESET2        ;if speed =0 then reset to 127
G1	   btfsc SPEED,7      ;is speed >128?
	   call RESET         ;yes, reset value of speed
           bsf FLAG,0         ;set the flag for next time
	   return 
	
RESET	   movlw 1            ;reset the speed to 1
           movwf SPEED	
           return

RESET2	   movlw 127          ;reset the speed to 127
           movwf SPEED	
           return	

RFLAG      clrf FLAG
	   goto DISPLAY
           		
           END


