;LED LOW RES SHADOW CAMERA - Version 1
;BRILLIANT LED PROJECTS - Nick Dossis - McGraw Hill 2011

#DEFINE BANK0 BCF STATUS,5
#DEFINE BANK1 BSF STATUS,5

           include p16f628.inc

	   CBLOCK h'20'
CLOCK
SPEED
	   ENDC

           __config  $3F30    ;internal 4MHz oscillator

           ORG 0              ;
           goto START
           ORG 4              ;
           goto START
           ORG 5              ; 

START:     movlw 7	      ;configure port A as a digital port
           movwf CMCON	      ;	
           clrf PORTA	      
           clrf PORTB	      
           BANK1		
           movlw B'00000000'  ;set all Port A as outputs
           movwf TRISA        ;
           movlw B'00000000'  ;set all Port B as outputs
           movwf PORTB
           movlw B'10000000'  ;TMR0 rate = 1:2
           movwf OPTION_REG   ;bit 7 is high = pull-ups off
           BANK0

	   clrf PORTA	      ;de-activate all outputs
	   clrf PORTB	      ;

;Camera sensor activation routines

CAMERA:	   bsf PORTB,6        ;activate 1st LDR
	   call PAUSE	      ;delay
           bcf PORTB,6        ;de-activate 1st LDR
	   
	   bsf PORTB,5        ;activate 2nd LDR
	   call PAUSE	      ;delay
           bcf PORTB,5        ;de-activate 2nd LDR

	   bsf PORTB,4        ;activate 3rd LDR
	   call PAUSE	      ;delay
           bcf PORTB,4        ;de-activate 3rd LDR

	   bsf PORTA,3        ;activate 4th LDR
	   call PAUSE	      ;delay
           bcf PORTA,3        ;de-activate 4th LDR

	   bsf PORTA,2        ;activate 5th LDR
	   call PAUSE	      ;delay
           bcf PORTA,2        ;de-activate 5th LDR

	   bsf PORTB,7        ;activate 6th LDR
	   call PAUSE	      ;delay
           bcf PORTB,7        ;de-activate 6th LDR

	   bsf PORTB,3        ;activate 7th LDR
	   call PAUSE	      ;delay
           bcf PORTB,3        ;de-activate 7th LDR

	   bsf PORTB,2        ;activate 8th LDR
	   call PAUSE	      ;delay
           bcf PORTB,2        ;de-activate 8th LDR

	   bsf PORTB,1        ;activate 9th LDR
	   call PAUSE	      ;delay
           bcf PORTB,1        ;de-activate 9th LDR

	   goto CAMERA        ;loop around

PAUSE      movlw 4            ;set the LDR display speed
           movwf CLOCK        ; 
           clrf INTCON        ;clear interrupt flag
                             
LOOP4      btfss INTCON,2     ;has the intcon timer time-out been detected?
           goto LOOP4         ;no, loop until it is detected
           bcf INTCON,2       ;yes, clear intcon
           decfsz CLOCK,F     ;decrement the clock counter, is it zero?
           goto LOOP4         ;no
           return             ;yes
		
           END


